#include "stdafx.h"
#include "B25.h"

CB25::CB25(void)
{
	m_hLib=NULL;
	m_pDecorder=NULL;
}

CB25::~CB25(void)
{
	Close();
}

BOOL CB25::Open(char *lpszInitStr)
{
	if(IsOpen()) Close();
	m_hLib = LoadLibraryA(lpszInitStr);
	if(!m_hLib) return FALSE;

	PFCREATEB25DECORDER *pfDec=(PFCREATEB25DECORDER*)GetProcAddress(m_hLib,"CreateB25Decoder");
	if(!pfDec)
	{
		Close();
		return FALSE;
	}
	m_pDecorder = pfDec();
	if(!m_pDecorder)
	{
		Close();
		return FALSE;
	}
	return TRUE;
}

void CB25::Close()
{
	if(!IsOpen()) return;
	if(m_pDecorder)
	{
		m_pDecorder->Release();
		m_pDecorder=NULL;
	}
	if(m_hLib)
	{
		FreeLibrary(m_hLib);
		m_hLib=NULL;
	}
}

BOOL CB25::IsOpen()
{
	return (m_hLib && m_pDecorder);
}

BOOL CB25::Initialize()
{
	if(!IsOpen()) return FALSE;
	return m_pDecorder->Initialize();
}

BOOL CB25::Reset()
{
	if(!IsOpen()) return FALSE;
	return m_pDecorder->Reset();
}

// gc[̒̐l Decord() ݊B ̕@ł put()̃G[ołȂ
BOOL CB25::DataPutAndGet(BYTE *pSrcBuf, DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!IsOpen()) return FALSE;
	return m_pDecorder->Decode(pSrcBuf,dwSrcSize,ppDstBuf,pdwDstSize);
}

// Marumoput()݊ B25Decorder.dllɂ͎ĂȂ
BOOL CB25::DataPut(BYTE *pSrcBuf, DWORD dwSrcSize)
{
	if(!IsOpen()) return FALSE;
	return FALSE;
}

// Marumoget()݊ B25Decorder.dllɂ͎ĂȂ
BOOL CB25::DataGet(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!IsOpen()) return FALSE;
	return FALSE;
}

// gc[̒̐l Flush() ݊B
BOOL CB25::DataFlush(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!IsOpen()) return FALSE;
	return m_pDecorder->Flush(ppDstBuf,pdwDstSize);
}
