// f[^pf[^Ǘ
// CBuffer *pBufœf[^ PSIHeader̐擪w
//
// głf[^͈kĂBzlibpĕ

#include "TsStreamCallback.h"

#pragma once
#include "../Common/Buffer.h"
#include "../Common/Lock.h"
#include "TsHeader.h"
#include <map>
#include <set>
#include <string>

#ifdef _DEBUG
	#define TSDATAMGR_DEBUG_PRINT
//	#define TSDATAMGR_DEBUG_PRINT_DETAIL
	#define TSDATAMGR_DEBUG_TRACE_MEMORY
#endif

#define TSDOWNLOAD_MODULE_MAX	128	// W[
#define TSDOWNLOAD_BLOCK_MAX	256	// PubNTCY4066ȉ
									// PW[őTCY͍ő254MBAȃf[^͂肦Ȃ͂Ȃ̂ŁA256ubNx4066byteő

class CTsDataMgr
{
public:
	CTsDataMgr(void);
	~CTsDataMgr(void);

	void SetCallback(PF_TSENGINE_CALLBACK lpFunc,LPVOID lpContext)
	{
		m_lpFunc = lpFunc;
		m_lpContext = lpContext;
	}

	void Clear();
	void ClearByPID(WORD wPID,bool bRemoveItem=true);

	bool OnDII(WORD wPID,BYTE *pBuf,int iPos,int iRemain,BYTE byComponentTag);
	bool OnDDB(WORD wPID,BYTE *pBuf,int iPos,int iRemain,BYTE byComponentTag);

	BOOL OutputDataContent(char *lpszDir,WORD wPID);
	BOOL GetData(char *szContent,PBYTE &pRetBuf, int &iRetSize);
	BOOL GetData(BYTE byComponentTag,WORD wModuleID,char *szFileName,PBYTE &pRetBuf, int &iRetSize);
	void FreeData(PBYTE &pRetBuf);

protected:
	// gpp\

	// _E[h
	struct TAG_DownloadData
	{
		bool bAllDownloadComplete;	// S_E[h
		BYTE byComponentTag;		// R|[lgԍ
		DWORD dwTransactionID;		//
		DWORD dwTransactionNo;		// dwTransactionID & 0x3FFFFFFF
		DWORD dwDownloadID;			//
		WORD wBlockSize;			//
		BYTE byWindowSize;			//
		BYTE byAckPriod;			//
		DWORD dwTcDownloadWindow;	//
		DWORD dwTcDownloadScenario;	//
		WORD wNumberOfModules;		//		
		struct
		{
			WORD wID;			// ID
			DWORD dwSize;		// f[^TCY
			BYTE byVersion;		// o[W
			WORD wBlockNum;		// _E[hubN̐
			struct {
				bool bFlg;		// kĂ邩
				BYTE byType;	// k(zlib)
				DWORD dwSize;	// WJ̃TCY
			} Compress;

			struct {
				bool bCompleteFlg;					// _E[hĂ邩
				bool bBlock[TSDOWNLOAD_BLOCK_MAX];	// 
				PBYTE pDownload;
			} Status;
		} Module[TSDOWNLOAD_MODULE_MAX];		
	};

	// Rec
	struct TAG_DownloadContent
	{
		BYTE byVersion;
		int iSize;
		char szType[80];
		char szEncoding[80];
		char szLocation[80];
		char szPath[80];
		// 
		PBYTE pContent;		
	};

	// Key=PID , Val=_E[h
	typedef std::map<WORD,TAG_DownloadData> TsDownloadData;
	typedef std::pair<WORD,TAG_DownloadData> TsDownloadDataPair;

	// LocationID쐬
	inline DWORD GetLocationID(BYTE byComponentTag,WORD wModuleID)
	{
		return ((DWORD)byComponentTag) << 16 | wModuleID;
	}
	// LocationIDComponentTagr
	inline bool CompareComponentTag(DWORD LocationID,BYTE byComponentTag)
	{
		return ((LocationID & 0xFF0000) >> 16 ) == byComponentTag ? true : false;
	}

	// Key=Content , Val=f[^
	typedef std::map<std::string,TAG_DownloadContent> TsContent;
	typedef std::pair<std::string,TAG_DownloadContent> TsContentPair;

	// Key=LocationID , Val=RecXg
	typedef std::map<DWORD,TsContent> TsContentLocation;
	typedef std::pair<DWORD,TsContent> TsContentLocationPair;

#ifdef TSDATAMGR_DEBUG_TRACE_MEMORY
	typedef std::map<PBYTE,int> TsBuffer_TraseSize;
	TsBuffer_TraseSize m_DownloadBuffer_TraseSize,m_ContentBuffer_TraseSize;
	DWORD		m_dwDownloadBufferSize;
	DWORD		m_dwContentBufferSize;
#endif

	// TCYg͂ȂBmۂȂ
	inline bool DownloadBuffer_Alloc(PBYTE &Pointer,int iSize)
	{
		DownloadBuffer_Free(Pointer);
		Pointer = new BYTE[iSize];
		if(!Pointer) return false;
#ifdef TSDATAMGR_DEBUG_TRACE_MEMORY
		m_dwDownloadBufferSize+=iSize;
		m_DownloadBuffer_TraseSize.insert(std::pair<PBYTE,int>(Pointer,iSize));
#endif
		return true;
	}
	inline void DownloadBuffer_Free(PBYTE &Pointer)
	{
		if(Pointer)
		{
#ifdef TSDATAMGR_DEBUG_TRACE_MEMORY
			TsBuffer_TraseSize::iterator it=m_DownloadBuffer_TraseSize.find(Pointer);
			if(it!=m_DownloadBuffer_TraseSize.end())
			{
				m_dwDownloadBufferSize-=it->second;
				m_DownloadBuffer_TraseSize.erase(it);
			}
#endif
			delete []Pointer;
			Pointer=NULL;
		}
	}
	inline bool ContentBuffer_Alloc(PBYTE &Pointer,int iSize)
	{
		ContentBuffer_Free(Pointer);
		Pointer = new BYTE[iSize];
		if(!Pointer) return false;
#ifdef TSDATAMGR_DEBUG_TRACE_MEMORY
		m_dwContentBufferSize+=iSize;
		m_ContentBuffer_TraseSize.insert(std::pair<PBYTE,int>(Pointer,iSize));
#endif
		return true;
	}
	inline void ContentBuffer_Free(PBYTE &Pointer)
	{
		if(Pointer)
		{
#ifdef TSDATAMGR_DEBUG_TRACE_MEMORY
			TsBuffer_TraseSize::iterator it=m_ContentBuffer_TraseSize.find(Pointer);
			if(it!=m_ContentBuffer_TraseSize.end())
			{
				m_dwContentBufferSize-=it->second;
				m_ContentBuffer_TraseSize.erase(it);
			}
#endif
			delete []Pointer;
			Pointer=NULL;
		}
	}

	void DoCallback(UINT uType=TSENG_CALLBACK_NONE,WORD wStreamID=0,void *pData=NULL,DWORD dwVal=0)
	{
		if(m_lpFunc)	m_lpFunc(uType,wStreamID,(BYTE*)pData,dwVal,m_lpContext);
	}

protected:
	LOCK_OBJ	m_DataLock;
	BYTE		*m_pPayloadTemp;
	TsDownloadData m_DownloadData;
	TsContentLocation m_Content;

	PF_TSENGINE_CALLBACK *m_lpFunc;
	LPVOID m_lpContext;

	int GetTextLine(PBYTE &pPtr,int &iRemain,PBYTE pBuf,int iBufSize);
	int GetHeader(PBYTE pHeader,PBYTE pBufHeaderName,int iBufSize,PBYTE &pHeaderData);
	int GetHeaderAttribute(PBYTE pHeaderData,char* pAttrName,PBYTE pBufAttrData,int iBufSize);
	bool ParseContent(BYTE byComponentTag,WORD wModuleID,BYTE byVersion,BYTE *pData,int iLen);
	bool StoreContent(BYTE byComponentTag,WORD wModuleID,BYTE *pData,TAG_DownloadContent &Content);
};
