#include "StdAfx.h"
#include "TsStream.h"

// Section Header
// ߂l̓wb_B0̎͒sł̎s
static int Parse_TsSectionHeader(struct TS_section_header *pTsSecHead,BYTE *pStream,int iLen)
{
	if(iLen<3) return 0;
	pTsSecHead->table_id                    =  pStream[0];
	pTsSecHead->section_syntax_indicator    = (pStream[1]&0x80)>>7;
	pTsSecHead->private_indicator           = (pStream[1]&0x30)>>6;
	pTsSecHead->section_length              = (((BYTE)(pStream[1]&0x0F))<<8) | pStream[2];
	if(pTsSecHead->section_syntax_indicator)
	{
		if(iLen<8) return 0;
		pTsSecHead->transport_stream_id     = (((BYTE)(pStream[3])     )<<8) | pStream[4];
		pTsSecHead->version_number          = (pStream[5]&0x3E)>>1;
		pTsSecHead->current_next_indicator  =  pStream[5]&0x01;
		pTsSecHead->section_number          =  pStream[6];
		pTsSecHead->last_section_number     =  pStream[7];
		return 8;
	} else {
		pTsSecHead->transport_stream_id     = 0;
		pTsSecHead->version_number          = 0;
		pTsSecHead->current_next_indicator  = 0;
		pTsSecHead->section_number          = 0;
		pTsSecHead->last_section_number     = 0;
		return 3;
	}
}

// ͂ꂽZNVAfR[_[֗
// ߂l=TRUEȂf[^ꂽAFALSEȂ珈ꂸobt@ɐς
BOOL CTsStream::OnSection(struct TS_header &stTsHeader,struct TS_section_header &stSecHeader,BYTE *pData,size_t len,PF_SECTION_CALLBACK *lpCallback,LPVOID lpContext)
{
	struct TS_PidInfo &stPIDinfo = m_stPidTable[stTsHeader.pid];
	CBuffer *pBuffer = stPIDinfo.pBuf;
#ifdef _DEBUG
	static char dbg_buf[188];
	memcpy(dbg_buf,pData,188);
#endif

	BOOL bRet=FALSE;
	int iPos,iRemain;
	int iNewPayloadOffset;
	int iRet;

	iPos=0;
	iRemain=static_cast<int>(len);
	iNewPayloadOffset=0;	
	
	if(stTsHeader.adaptation_field_control&0x02)
	{
		// A_ve[VtB[h݂
		int iAdaptationFieldLength=pData[iPos];
		iPos+=(iAdaptationFieldLength+1);
		iRemain-=(iAdaptationFieldLength+1);
	}
	
	if(stTsHeader.payload_unit_start_indicator)
	{
		iNewPayloadOffset=pData[iPos];
		iPos++;
		iRemain--;
	}

	if(iNewPayloadOffset>0)
	{
		if(stPIDinfo.bStartFlg)
		{
			// OPSIZNV̑܂
			pBuffer->Put(pData+iPos,iNewPayloadOffset);
//			bRet |= (TS_TABLE_SUCCESS==CheckSection(stTsHeader,stSecHeader,pBuffer,lpCallback,lpContext));
			iRet = CheckSection(stTsHeader,stSecHeader,pBuffer,lpCallback,lpContext);
			bRet |=(TS_TABLE_SUCCESS==iRet);
			if(iRet==TS_TABLE_ERR_CRC)
			{
				// CRCvȂȂ猻Sɏ
				stPIDinfo.bStartFlg=FALSE;
				pBuffer->Clear();
			}
		}
		iPos+=iNewPayloadOffset;
		iRemain-=iNewPayloadOffset;		
	}

	if(iRemain>0)
	{
		if(stTsHeader.payload_unit_start_indicator)
		{
			// VPSIZNV̊Jn
			stPIDinfo.bStartFlg=TRUE;
			pBuffer->Clear();
		}
		if(stPIDinfo.bStartFlg)
		{			
			pBuffer->Put(pData+iPos,iRemain);
			iRet = CheckSection(stTsHeader,stSecHeader,pBuffer,lpCallback,lpContext);
			bRet |=(TS_TABLE_SUCCESS==iRet);
			if(iRet==TS_TABLE_ERR_CRC)
			{
				// CRCvȂȂ猻Sɏ
				stPIDinfo.bStartFlg=FALSE;
				pBuffer->Clear();
			}
		}
	}
	return bRet;
}

// ZNṼwb_擾Ɠe
int CTsStream::CheckSection(struct TS_header &stTsHeader,struct TS_section_header &stSecHeader,CBuffer *pBuffer,PF_SECTION_CALLBACK *lpCallback,LPVOID lpContext)
{
	int iPos = 0;
	int iLen = pBuffer->GetDataSize();

	if(iLen<3)
	{
		return TS_TABLE_ERR_LENGTH;
	} else {
		BYTE buf_hdr[8];
		int hdr_len=pBuffer->Get(buf_hdr,8,FALSE);
		iPos=Parse_TsSectionHeader(&stSecHeader,buf_hdr,hdr_len);
	}

	// ZNVfobO
	/*{
		if(stSecHeader.table_id==0x4E)
		{
			char dbg_buf[100];
			wsprintf(dbg_buf,"PID=0x%04X ID=%d Table=0x%04X Section %d/%d Size=%d/%d %s\n",
				stTsHeader.pid,
				stSecHeader.transport_stream_id,
				stSecHeader.table_id,
				stSecHeader.section_number,stSecHeader.last_section_number,
				pBuffer->GetDataSize(),stSecHeader.section_length+3,
				pBuffer->GetDataSize()>=stSecHeader.section_length+3?"<<OK>>":""
				);
			OutputDebugString(dbg_buf);
			dbg_buf[0]=dbg_buf[0];
		}
	}*/

	// ZNV
	if(pBuffer->GetDataSize()<stSecHeader.section_length+3)
	{
		return TS_TABLE_ERR_LENGTH;
	}

	// CRC(߂l0łΐ,+3=(table_idsectionlength܂ł̒3byte))
	DWORD crc = pBuffer->crc32((DWORD)stSecHeader.section_length+3);
	if(crc!=0)
	{
		pBuffer->Clear();
		return TS_TABLE_ERR_CRC;
	}

	if(lpCallback)
	{
		lpCallback(stTsHeader,stSecHeader,pBuffer,lpContext);
	}
	return TS_TABLE_SUCCESS;
}

BOOL CTsStream::OnPAT(struct TS_header &stTsHeader,struct TS_section_header&stSecHeader,CBuffer *pBuf,LPVOID lpContext)
{
	CTsStream *pThis=static_cast<CTsStream*>(lpContext);

	int iPos=stSecHeader.section_syntax_indicator?8:3;
	int iRemain=static_cast<int>(stSecHeader.section_length-iPos+3-4);

	BYTE *pSection=pThis->m_pPayloadTemp;
//	BYTE pSection[TS_MAX_PAYLOAD_LENGTH];
	if(pBuf->Get(pSection,static_cast<DWORD>(stSecHeader.section_length)+3)<stSecHeader.section_length+3)
	{
		return FALSE;
	}
	TS_CurrentStreamInfo& stCurStream=pThis->m_stCurrentStream;
	std::map<DWORD,WORD>& PsiVerNo = pThis->m_PsiVerNo;
	
	BOOL bPatUpdate=FALSE;	
	bPatUpdate = pThis->IsPsiUpdate(stSecHeader.transport_stream_id,stSecHeader.table_id,stSecHeader.section_number,stSecHeader.version_number);
	if(stCurStream.wStreamID!=stSecHeader.transport_stream_id)
	{
		// ʃXg[Ă
		pThis->ResetStream();
		pThis->DoCallback(TSENG_CALLBACK_STREAM_RESET,stSecHeader.transport_stream_id,NULL,0);
		if(pThis->m_pB25)
		{
			// B25Zbg(Œł1PAT0.1b͎̃f[^Ȃ)
			pThis->m_pB25->Reset();
		}
		// Reset̂Vero^Ȃ
		bPatUpdate = pThis->IsPsiUpdate(stSecHeader.transport_stream_id,stSecHeader.table_id,stSecHeader.section_number,stSecHeader.version_number);
	}
	if(bPatUpdate)
	{
		struct TS_SERVICE stService;
		struct TAG_TSCB_PATITEM *pstItem=NULL;
		int i;
		int iPatItemCount=0;

		stCurStream.wStreamID=stSecHeader.transport_stream_id;
		
		pThis->m_CurrentPAT.Programs.clear();
		for(i=0;i<iRemain;i+=4)
		{
			stService.service_number= (WORD)(pSection[iPos+i+0]     )<<8 | pSection[iPos+i+1];
			stService.pmt_pid       = (WORD)(pSection[iPos+i+2]&0x1f)<<8 | pSection[iPos+i+3];
			if(stService.service_number==0)
			{
				// service_number=0NIT/SIT̎w
				if(stService.pmt_pid==0x10)
				{
					pThis->m_stPidTable[stService.pmt_pid].type=TS_TABLE_ID_NIT;
				} else {
					// 炭PID=0x1F
					pThis->m_stPidTable[stService.pmt_pid].type=TS_TABLE_ID_SIT;
				}
			} else 	{
				// PMT̎w
				pThis->m_stPidTable[stService.pmt_pid].type=TS_TABLE_ID_PMT;
				pThis->m_CurrentPAT.Programs.push_back(stService);
				// Service
				// {͂xubN܂Ƃ߂ĊmۂقAĂ΂񐔂ɒ[ɂȂ̂ŁB
				pstItem=(struct TAG_TSCB_PATITEM*)realloc(pstItem,sizeof(struct TAG_TSCB_PATITEM)*(iPatItemCount+1));
				if(pstItem)
				{
					pstItem[iPatItemCount].wProgramID=stService.service_number;
					pstItem[iPatItemCount].wPID=stService.pmt_pid;
					iPatItemCount++;
				}
			}
		}
		if(pstItem)
		{
 			pThis->DoCallback(TSENG_CALLBACK_PAT_RECIEVE,stCurStream.wStreamID,pstItem,iPatItemCount);
			free(pstItem);
		}
	}

	return TRUE;
}

BOOL CTsStream::OnPMT(struct TS_header &stTsHeader,struct TS_section_header&stSecHeader,CBuffer *pBuf,LPVOID lpContext)
{
	CTsStream *pThis=static_cast<CTsStream*>(lpContext);

	int iPos=stSecHeader.section_syntax_indicator?8:3;
	int iRemain=static_cast<int>(stSecHeader.section_length-iPos+3-4);

	BYTE *pSection=pThis->m_pPayloadTemp;
//	BYTE pSection[TS_MAX_PAYLOAD_LENGTH];
	if(pBuf->Get(pSection,static_cast<DWORD>(stSecHeader.section_length)+3)<stSecHeader.section_length+3)
	{
		return FALSE;
	}
	std::map<DWORD,WORD>& PsiVerNo = pThis->m_PsiVerNo;

	BOOL bPmtUpdate=FALSE;
	bPmtUpdate = pThis->IsPsiUpdate(stSecHeader.transport_stream_id,stSecHeader.table_id,stSecHeader.section_number,stSecHeader.version_number);
	if(bPmtUpdate)
	{
		struct TS_PMT stPMT;
		int i,j;

		stPMT.pcr_pid = (WORD)(pSection[iPos+0]&0x1f)<<8 | pSection[iPos+1];
		WORD desc_all_len=(WORD)(pSection[iPos+2]&0x0f)<<8 | pSection[iPos+3];
		iPos+=4;
		iRemain-=4;
		for(i=0;i<desc_all_len;)
		{
			BYTE byTag =pSection[iPos+i];
			BYTE bySize=pSection[iPos+i+1];
			i+=bySize+2;
		}
		iPos+=desc_all_len;
		iRemain-=desc_all_len;

		struct TAG_TSCB_PMTITEM *pstItem=NULL;
		int iPmtItemCount=0;
		
		stPMT.ProgramInfo.clear();
		for(i=0;i<iRemain;)
		{
			struct TS_PROGRAM_INFO stProgInfo;
			stProgInfo.program_type =pSection[iPos+i];
			stProgInfo.elementary_pid=(WORD)(pSection[iPos+i+1]&0x1f)<<8 | pSection[iPos+i+2];
			stPMT.ProgramInfo.push_back(stProgInfo);
			WORD wESDescSize=(WORD)(pSection[iPos+i+3]&0x07)<<8 | pSection[iPos+i+4];
			switch(stProgInfo.program_type)
			{
			case 0x0D:
				{
					pThis->m_stPidTable[stProgInfo.elementary_pid].type = TS_TABLE_ID_DATA;
				}
				break;
			}
			for(j=0;j<wESDescSize;)
			{
				BYTE byTag =pSection[iPos+i+5+j];
				BYTE bySize=pSection[iPos+i+5+j+1];
				switch(byTag)
				{
				case 0x52:
					{
						// Xg[ʋLqq
						pThis->m_stPidTable[stProgInfo.elementary_pid].byComponentTag = pSection[iPos+i+5+j+2];
					}
					break;
				}
				j+=bySize+2;
			}

			pstItem=(struct TAG_TSCB_PMTITEM*)realloc(pstItem,sizeof(struct TAG_TSCB_PMTITEM)*(iPmtItemCount+1));
			if(pstItem)
			{
				pstItem[iPmtItemCount].byType=stProgInfo.program_type;
				pstItem[iPmtItemCount].wPID=stProgInfo.elementary_pid;
				iPmtItemCount++;
			}
			i+=wESDescSize+5;
		}
		if(pstItem)
		{
			pThis->DoCallback(TSENG_CALLBACK_PMT_RECIEVE,stSecHeader.transport_stream_id,pstItem,iPmtItemCount);
			free(pstItem);
		}
	}
	return TRUE;
}

// NitSit͓ɂ邱Ƃ͂قڍlȂ̂Ńo[W͋p
BOOL CTsStream::OnNIT_SIT(struct TS_header &stTsHeader,struct TS_section_header&stSecHeader,CBuffer *pBuf,LPVOID lpContext)
{
	CTsStream *pThis=static_cast<CTsStream*>(lpContext);

	int iPos=stSecHeader.section_syntax_indicator?8:3;
	int iRemain=static_cast<int>(stSecHeader.section_length-iPos+3-4);

//	BYTE *pSection=pThis->m_pPayloadTemp;
	BYTE pSection[TS_MAX_PAYLOAD_LENGTH];
	if(pBuf->Get(pSection,static_cast<DWORD>(stSecHeader.section_length)+3)<stSecHeader.section_length+3)
	{
		return FALSE;
	}

	BOOL bNitSitUpdate = pThis->IsPsiUpdate(stSecHeader.transport_stream_id,stSecHeader.table_id,stSecHeader.section_number,stSecHeader.version_number);
	if(bNitSitUpdate)
	{
		unsigned int i,j,k;
		char szNetworkName[21];
		if(stSecHeader.table_id==TS_TABLE_ID_NIT)
		{
			// 1st Loop
			WORD wDescSize =(WORD)(pSection[iPos]&0x0f)<<8 | pSection[iPos+1];
			iPos+=2;
			iRemain-=2;
			for(i=0;i<wDescSize;)
			{				
				BYTE byTag =pSection[iPos+i+0];
				BYTE bySize=pSection[iPos+i+1];
				switch(byTag)
				{
				case 0x40:
					{
						Convert_jpn_arib_char((char*)&pSection[iPos+i+2],bySize,szNetworkName,21);
					}
					break;
				}
				i+=bySize+2;
			}
			iPos+=wDescSize;
			iRemain-=wDescSize;
			// 2nd Loop
			WORD wTsLoop=(WORD)(pSection[iPos]&0x0f)<<8 | pSection[iPos+1];
			iPos+=2;
			iRemain-=2;
			for(i=0;i<wTsLoop;)
			{
				struct TAG_TSCB_SATELLITE stSatInfo;
				ZeroMemory(&stSatInfo,sizeof(stSatInfo));
				WORD wTsID=(WORD)(pSection[iPos+i])<<8 | pSection[iPos+i+1];
				WORD wNetID=(WORD)(pSection[iPos+i+2])<<8 | pSection[iPos+i+3];
				wDescSize =(WORD)(pSection[iPos+i+4]&0x0f)<<8 | pSection[iPos+i+5];
				for(j=0;j<wDescSize;)
				{
					BYTE byTag =pSection[iPos+i+6+j+0];
					BYTE bySize=pSection[iPos+i+6+j+1];
					switch(byTag)
					{
					case 0x41:
						{
							WORD wServiceID=(WORD)(pSection[iPos+i+6+j+2])<<8 | pSection[iPos+i+6+j+3];
							for(k=2;k<bySize;k++)
							{
								// T[rX^Cv
							}
						}
						break;
					case 0x43:
						{
							// q
							DWORD dwFrequencyBCD=(DWORD)(pSection[iPos+i+6+j+2])<<24 | (DWORD)(pSection[iPos+i+6+j+3])<<16 | (DWORD)(pSection[iPos+i+6+j+4])<<8 | pSection[iPos+i+6+j+5];
							WORD wPositionBCD=(WORD)(pSection[iPos+i+6+j+6])<<8 | pSection[iPos+i+6+j+7];
							stSatInfo.lfFrequency=(double)(Convert_bcd_to_dword(dwFrequencyBCD))/100.0;
							stSatInfo.lfPosition=(double)(Convert_bcd_to_dword(wPositionBCD))/10.0;
							stSatInfo.bEastFlg=pSection[iPos+i+6+j+8]&0x80?TRUE:FALSE;
							stSatInfo.byPolarization=(pSection[iPos+i+6+j+8]&0x60)>>5;
							stSatInfo.byModulation=pSection[iPos+i+6+j+8]&0x1F;
							DWORD dwRateBCD=(DWORD)(pSection[iPos+i+6+j+9])<<20 | (DWORD)(pSection[iPos+i+6+j+10])<<12 | (DWORD)(pSection[iPos+i+6+j+11])<<4 | pSection[iPos+i+6+j+12]>>4;
							stSatInfo.lfRate=(double)(Convert_bcd_to_dword(dwRateBCD))/10000.0;							
							stSatInfo.byFEC_inner=pSection[iPos+i+6+j+12]&0x0F;							
						}
						break;
					}
					j+=bySize+2;
				}
				i+=wDescSize+6;
				pThis->DoCallback(TSENG_CALLBACK_SATELLITE_INFO,stSecHeader.transport_stream_id,&stSatInfo,wTsID);
			}
			pThis->DoCallback(TSENG_CALLBACK_NIT_RECIEVE,stSecHeader.transport_stream_id,szNetworkName,0);
		}
		else if(stSecHeader.table_id==TS_TABLE_ID_SIT)
		{
			pThis->DoCallback(TSENG_CALLBACK_NIT_RECIEVE,stSecHeader.transport_stream_id,"",1);
		}
	}
	return TRUE;
}

// yC[hƂ󋵂vȂ̂ŗ]vȏȂĂ(KvȂ̂CRC炢H)
// Ƃlicarc\L킩ɂ
BOOL CTsStream::OnTOT(struct TS_header &stTsHeader,struct TS_section_header&stSecHeader,CBuffer *pBuf,LPVOID lpContext)
{
	CTsStream *pThis=static_cast<CTsStream*>(lpContext);

	int iPos=stSecHeader.section_syntax_indicator?8:3;
	int iRemain=static_cast<int>(stSecHeader.section_length-iPos+3-4);

	BYTE *pSection=pThis->m_pPayloadTemp;
//	BYTE pSection[TS_MAX_PAYLOAD_LENGTH];
	if(pBuf->Get(pSection,static_cast<DWORD>(stSecHeader.section_length)+3)<stSecHeader.section_length+3)
	{
		return FALSE;
	}
	TS_CurrentStreamInfo &stCurStream=pThis->m_stCurrentStream;

	stCurStream.wMJDdate=((WORD)(pSection[iPos+0])<<8)|pSection[iPos+1];
	stCurStream.dwBCDtime=0x000000;
	memcpy(&stCurStream.dwBCDtime,pSection+iPos+2,3);

	struct TAG_TSCB_TIME stTime;
	stTime.stDateTime.Date=stCurStream.wMJDdate;
	stTime.stDateTime.Time=CDateTime::ConvertFrom_BcdTime(pSection[iPos+2],pSection[iPos+3],pSection[iPos+4]);
	stTime.dwTimeBCD=stCurStream.dwBCDtime;	
	stTime.byHour=(pSection[iPos+2]>>4)*10 + (pSection[iPos+2]&0xf);
	stTime.byMin=(pSection[iPos+3]>>4)*10 + (pSection[iPos+3]&0xf);
	stTime.bySec=(pSection[iPos+4]>>4)*10 + (pSection[iPos+4]&0xf);
	pThis->DoCallback(TSENG_CALLBACK_TIME_RECIEVE,0,&stTime,0);
	return TRUE;
}


// ActualŌĂ΂قږȂ
BOOL CTsStream::OnSDT(struct TS_header &stTsHeader,struct TS_section_header&stSecHeader,CBuffer *pBuf,LPVOID lpContext)
{
	CTsStream *pThis=static_cast<CTsStream*>(lpContext);

	int iPos=stSecHeader.section_syntax_indicator?8:3;
	int iRemain=static_cast<int>(stSecHeader.section_length-iPos+3-4);

	BYTE *pSection=pThis->m_pPayloadTemp;
//	BYTE pSection[TS_MAX_PAYLOAD_LENGTH];
	if(pBuf->Get(pSection,static_cast<DWORD>(stSecHeader.section_length)+3)<stSecHeader.section_length+3)
	{
		return FALSE;
	}

	BOOL bSDTUpdate=FALSE;

	// _łBDT͑ΉĂȂ(id==0x46other)
	if(stSecHeader.table_id==0x42||stSecHeader.table_id==0x46)
	{
		bSDTUpdate = pThis->IsPsiUpdate(stSecHeader.transport_stream_id,stSecHeader.table_id,stSecHeader.section_number,stSecHeader.version_number);
		if(bSDTUpdate)
		{
			int i,j;
			WORD orig_network_id=(WORD)(pSection[iPos+0])<<8 | pSection[iPos+1];
			pSection+=3;
			iRemain-=3;

			for(i=0;i<iRemain;)
			{
				char szProviderName[30]="";
				char szChannelName[30]="";
				WORD wServiceID=(WORD)(pSection[iPos+i+0])<<8 | pSection[iPos+i+1];
				WORD wDescSize =(WORD)(pSection[iPos+i+3]&0x0f)<<8 | pSection[iPos+i+4];

				for(j=0;j<wDescSize;)
				{
					BYTE byTag =pSection[iPos+i+5+j];
					BYTE bySize=pSection[iPos+i+5+j+1];
					// `lfR[h
					if(byTag==0x48)
					{
						BYTE byProviderNameLen=pSection[iPos+i+5+j+3];
						Convert_jpn_arib_char((char*)&pSection[iPos+i+5+j+4],byProviderNameLen,szProviderName,30);
						BYTE byChannelNameLen=pSection[iPos+i+5+j+4+byProviderNameLen];
						Convert_jpn_arib_char((char*)&pSection[iPos+i+5+j+5+byProviderNameLen],byChannelNameLen,szChannelName,30);
					}
					j+=bySize+2;
				}			
				// fobOp SDT\(Actual͐擪*)
				/*{
					char tmp[80];
					wsprintf(tmp,"%c %d %s %s\n",
						stSecHeader.table_id==0x42?'*':' ',
						wServiceID,szProviderName,szChannelName);
					OutputDebugString(tmp);
				}*/

				// T[rXXgXV
				TsServiceInfoMap::iterator itService=pThis->m_ServiceInfo .find(wServiceID);
				if(itService==pThis->m_ServiceInfo.end())
				{
					// VK
					TS_ServiceInfo stNew;
					ZeroMemory(&stNew,sizeof(stNew));
					lstrcpynA(stNew.szServiceName,szChannelName,30);
					pThis->m_ServiceInfo.insert(TsServiceInfoPair(wServiceID,stNew));
				} else {
					// XV
					TS_ServiceInfo &stUpdate=itService->second;
					lstrcpynA(stUpdate.szServiceName,szChannelName,30);
				}
				// SDTʒm
				pThis->DoCallback(TSENG_CALLBACK_SDT_RECIEVE,wServiceID,szChannelName,0);
				i+=wDescSize+5;
			}
		}
	}
	return TRUE;
}

// ԑgz
BOOL CTsStream::OnEIT(struct TS_header &stTsHeader,struct TS_section_header&stSecHeader,CBuffer *pBuf,LPVOID lpContext)
{
	CTsStream *pThis=static_cast<CTsStream*>(lpContext);

	int iPos=stSecHeader.section_syntax_indicator?8:3;
	int iRemain=static_cast<int>(stSecHeader.section_length-iPos+3-4);

	BYTE *pSection=pThis->m_pPayloadTemp;
//	BYTE pSection[TS_MAX_PAYLOAD_LENGTH];
	if(pBuf->Get(pSection,static_cast<DWORD>(stSecHeader.section_length)+3)<stSecHeader.section_length+3)
	{
		return FALSE;
	}

	// EPGȂȂA̐̏Ȃ
	if(!pThis->m_bProcEpg) return TRUE;

	// p/fƎschedulê(0x58ȍ~͎Ǌg,0x60ȍ~͑ǂ̂ߖ)
	if(stSecHeader.table_id>=0x58) return TRUE;

	BOOL bEitUpdate=FALSE;
	BOOL bActual=(stSecHeader.table_id==0x4E||(stSecHeader.table_id>=0x50&&stSecHeader.table_id<0x60))?TRUE:FALSE;
	bEitUpdate = pThis->IsPsiUpdate(stSecHeader.transport_stream_id,stSecHeader.table_id,stSecHeader.section_number,stSecHeader.version_number);
	if(bEitUpdate)
	{		
		int i;		
		WORD wTsID =(WORD)(pSection[iPos+0])<<8 | pSection[iPos+1];
		WORD wNetID=(WORD)(pSection[iPos+2])<<8 | pSection[iPos+3];
		BYTE byLastSection=pSection[iPos+4];
		BYTE byLastTable  =pSection[iPos+5];

		iPos+=6;
		iRemain-=6;
		for(i=0;i<iRemain;)
		{
			struct TSEPG_PROGRAM *pstProg;
			int iProgCount=0;
			int iRet=CTsEPGMgr::TsEitParser(&pstProg,&iProgCount,stSecHeader.table_id,stSecHeader.version_number,stSecHeader.transport_stream_id,&pSection[iPos+i]);
			if(iProgCount==0) break;
			for(int j=0;j<iProgCount;j++)
			{
				if(pThis->m_EpgMgr.SetEpgData(pstProg[j].wServiceID,&pstProg[j]))
				{
					// EPGǉ͍XVꂽ
					if(stSecHeader.table_id<0x50)
					{
						// p/fʒm
						pThis->DoCallback(TSENG_CALLBACK_EIT_PF_RECIEVE,stSecHeader.transport_stream_id,&pstProg[j],bActual);
					} else {
						// scheduleʒm
						pThis->DoCallback(TSENG_CALLBACK_EIT_SCHEDULE_RECIEVE,stSecHeader.transport_stream_id,&pstProg[j],bActual);
					}
					// debugp\
					CTsEPGMgr::TsEitParser_DebugPrintProgram(bActual,stSecHeader,pstProg[j]);
				}
			}
			CTsEPGMgr::FreeTsEitParserMemory(pstProg,iProgCount);			
			i+=iRet;
		}
	}
	return TRUE;
}

// f[^(o[W͓ƎǗȂ̂ŁAPSIƓ@ōXV`FbNȂ)
BOOL CTsStream::OnData(struct TS_header &stTsHeader,struct TS_section_header&stSecHeader,CBuffer *pBuf,LPVOID lpContext)
{
	CTsStream *pThis=static_cast<CTsStream*>(lpContext);
	int iPos=stSecHeader.section_syntax_indicator?8:3;
	int iRemain=static_cast<int>(stSecHeader.section_length-iPos+3-4);

	BYTE *pSection=pThis->m_pPayloadTemp;
//	BYTE pSection[TS_MAX_PAYLOAD_LENGTH];
	if(pBuf->Get(pSection,static_cast<DWORD>(stSecHeader.section_length)+3)<stSecHeader.section_length+3)
	{
		return FALSE;
	}

	if(stTsHeader.transport_scrambling_control==0)
	{
		switch(stSecHeader.table_id)
		{
		case 0x3B:
			{
				// DII
				return pThis->m_DataMgr.OnDII(stTsHeader.pid,pSection,iPos,iRemain,pThis->m_stPidTable[stTsHeader.pid].byComponentTag);
			}
			break;
		case 0x3C:
			{
				// DDB
				return pThis->m_DataMgr.OnDDB(stTsHeader.pid,pSection,iPos,iRemain,pThis->m_stPidTable[stTsHeader.pid].byComponentTag);
			}
			break;
		}
	}
	return TRUE;
}
